#!/bin/bash

#
#  Install script for TCP/IP stack lwIP
#  URL: http://savannah.nongnu.org/projects/lwip/
#
#  Script written by Gregor Rebel 2010-2011.
# 
#  Feel free do distribute and change to your own needs!
#
# Tested successfully on:
# openSuSE 11.4 x86
# XUbuntu 11.10 x64

source scripts/installFuncs.sh

if [ "$USER" == "root" ]; then
  echo "$0: ERROR this script should not been run as user root!"
  exit 10
fi

INSTALLPATH="network_lwip"
dir $INSTALLPATH
cd $INSTALLPATH

#{ IMPLEMENT YOUR INSTALL SCRIPT BELOW -----------------------------------------------


if [ ! -e OK.Install ]; then #{
  echo "installing in $INSTALLPATH ..."
  InstallDir=`pwd`

  if [ ! -e OK.Packages ]; then #{
    installPackage git
    touch OK.Packages
  fi #}

  gitClone git://git.savannah.nongnu.org/lwip.git lwip
  
  #get http://download.savannah.gnu.org/releases/lwip/lwip-1.4.0.zip
fi
#}
if [ ! -e OK.Install ]; then #{

  addLine ../scripts/createLinks.sh "rm 2>/dev/null $INSTALLPATH;  ln -sv \$Source/ToolChain_STM32/ToolChain/$INSTALLPATH/lwip/  $INSTALLPATH"
  cat <<END_OF_MAKEFILE >../extensions/makefile.$INSTALLPATH #{
#
#                               ToolChain_STM32
#
#                         Extension to central makefile
#
#                   makefile written by Gregor Rebel 2010-2011
#

EXTENSION_$INSTALLPATH = 1

ifdef EXTENSION_$INSTALLPATH
  
  # activate certain parts of source-code
  COMPILE_OPTS += -DEXTENSION_$INSTALLPATH

  ifndef uCONTROLLER
    STM32F10X_HD   = 1
    uCONTROLLER    = STM32F10X_HD 
  endif
  
  INCLUDE_DIRS += -I additionals/examples/
  vpath %.c additionals/examples/
  
  MAIN_OBJS += 

endif

END_OF_MAKEFILE
#}
  echo "Installed successfully: $INSTALLPATH"

fi
#}
cd ..
#} IMPLEMENT YOUR INSTALL SCRIPT ABOVE -----------------------------------------------

exit 0
